//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//-============================================================================
//  GNXv[tH[ɔzuĎgp邽߂̃NX(R|[lg)
//  tH_c[̃yC\
//
//  EternalWindowsƂTCg̈ȉ̃y[WC++R[hDelphiɈڐA
//  [NameSpaceTreeControl̍쐬]
//  http://eternalwindows.jp/shell/explorerbrowser/explorerbrowser04.html
//
//  GNXv[֌W̃C^[tFCXIuWFNg悹(\)߂
//  TCustomPanel𐶐CŏɃ[gtH_ݒ肷鎞ɃGNXv[֌W
//  ̃IuWFNg𐶐
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؂̊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2010N1121 `
//  2010N1123
//  EtH_r[Ƃ̘Aĝ߂ɍڎʎqɂ郋[gCItH_̃v
//    peBǉD[gtH_ύXƑItH_ύX̃Cxgǉ
//  2010N1125
//  EILFreeCoTaskMemFreeɏC
//  2010N1227
//  EC^[tFCXTCustomPanel̃o[ɂāCDelphi炵pR[h
//    ɕύX
//  EtH_c[̃nhvpeBɂ
//  2011N0920
//  EC^[tFCXsɐR[hɕύX
//  EDelphi 2010ł̎QƃJE^̖C(Delphi XE2ł͂̏C͕sv)
//    fobN[hł̗Ỏ
//    ڍׂ̓ICwv[QƃJEggȂ][QƃJEg̎g]Q
//  EXbh̎gp~߂āCOnIdleCxgɕύX
//
//-----------------------------------------------------------------------------
//
//  ymFz 
//
//  Windows 7 U64 + Delphi 2010(UP5) Pro
//                + Delphi XE Pro
//                + Delphi XE2 Pro VCL-32, VCL-64
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//-============================================================================
unit plExplorerFolderTree;

interface

uses
  {$IF CompilerVersion < 23.0}
  Windows, Messages, SysUtils, Variants, Classes, Controls, ShlObj, ActiveX,
  ExtCtrls, Graphics, Types, Forms;
  {$ELSE}
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Controls, Winapi.ShlObj, Winapi.ActiveX, Vcl.ExtCtrls, Vcl.Graphics,
  System.Types, Vcl.Forms;
  {$IFEND}

type
  TpExplorerFolderTreeChanged  = procedure(Sender: TObject; pidlFolder: PItemIDList;
                                          AFullPath: String) of object;

  TplExplorerFolderTree = class(TCustomPanel, INameSpaceTreeControlCustomDraw)
  private
    FRootFolder           : String;
    FSelectFolder         : String;
    FpidlRootFolder       : PItemIDList;
    FpidlSelectFolder     : PItemIDList;
    FOnRootFolderChanged  : TpExplorerFolderTreeChanged;
    FOnSelctFolderChanged : TpExplorerFolderTreeChanged;

    FhwndTree               : HWND;
    m_dwTreeCookie          : DWORD;
    m_pNameSpaceTreeControl : INameSpaceTreeControl;
    m_pShellItem            : IShellItem;

    procedure SetFRootFolder(const Value: String);
    procedure SetFSelectFolder(const Value: String);
    procedure SetFpidlSelectFolder(const Value: PItemIDList);
  protected
    procedure WndProc(var Message: TMessage); override;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure Paint; override;

    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;

    function PrePaint(hdc: HDC; var prc: TRect;
      var plres: LRESULT): HRESULT; stdcall;
    function PostPaint(hdc: HDC; var prc: TRect): HRESULT; stdcall;
    function ItemPrePaint(hdc: HDC; var prc: TRect; var pnstccdItem: TNSTCCustomDraw;
      var pclrText: COLORREF; var pclrTextBk: COLORREF;
      var plres: LRESULT): HRESULT; stdcall;
    function ItemPostPaint(hdc: HDC; var prc: TRect;
      var pnstccdItem: TNSTCCustomDraw): HRESULT; stdcall;

    procedure SetParent(AParent: TWinControl); override;
    procedure OnIdleEvent(Sender: TObject; var Done: Boolean);

  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property pidlRootFolder   : PItemIDList read FpidlRootFolder;
    property pidlSelectFolder : PItemIDList read FpidlSelectFolder
                                            write SetFpidlSelectFolder;
    property hwndTree : HWND read FhwndTree;

  published
    property Caption;
    property Align;
    property Anchors;
    property RootFolder   : String read FRootFolder   write SetFRootFolder;
    property SelectFolder : String read FSelectFolder write SetFSelectFolder;
    property OnRootFolderChanged   : TpExplorerFolderTreeChanged
                                     read  FOnRootFolderChanged
                                     write FOnRootFolderChanged;
    property OnSelectFolderChanged : TpExplorerFolderTreeChanged
                                     read  FOnSelctFolderChanged
                                     write FOnSelctFolderChanged;
  end;

  fIUnknown_GetWindow = function (punk: IUnknown; out phwnd: HWND): HRESULT; stdcall;

  procedure Register;

implementation

const
  CDRF_DODEFAULT         = $00000000;
  CDRF_NEWFONT           = $00000002;
  CDRF_SKIPDEFAULT       = $00000004;
  CDRF_DOERASE           = $00000008;
  CDRF_NOTIFYPOSTPAINT   = $00000010;
  CDRF_NOTIFYITEMDRAW    = $00000020;
  CDRF_NOTIFYSUBITEMDRAW = $00000020;
  CDRF_NOTIFYPOSTERASE   = $00000040;
  CDRF_SKIPPOSTPAINT     = $00000100;

  CDIS_SELECTED         = $0001;
  CDIS_GRAYED           = $0002;
  CDIS_DISABLED         = $0004;
  CDIS_CHECKED          = $0008;
  CDIS_FOCUS            = $0010;
  CDIS_DEFAULT          = $0020;
  CDIS_HOT              = $0040;
  CDIS_MARKED           = $0080;
  CDIS_INDETERMINATE    = $0100;
  CDIS_SHOWKEYBOARDCUES = $0200;
  CDIS_NEARHOT          = $0400;
  CDIS_OTHERSIDEHOT     = $0800;
  CDIS_DROPHILITED      = $1000;

var
  IUnknown_GetWindow : fIUnknown_GetWindow;

{ TplExplorerFolderTree }

//-============================================================================
//  tH_c[IuWFNg悹(\)TWinControl̐
//-============================================================================
constructor TplExplorerFolderTree.Create(AOwner: TComponent);
var
  DLLHandle : THandle;
begin
  inherited Create(AOwner);

  DLLHandle := LoadLibrary('shlwapi.dll');
  if DLLHandle <> 0 then begin
    @IUnknown_GetWindow := GetProcAddress(DLLHandle,'IUnknown_GetWindow');
  end;

  BevelOuter              := bvNone;
  FRootFolder             := '';;
  FSelectFolder           := '';
  FpidlRootFolder         := nil;
  FpidlSelectFolder       := nil;
  m_dwTreeCookie          := 0;
  m_pNameSpaceTreeControl := nil;
  m_pShellItem            := nil;

  Width  := 250;
  Height := 300;
end;

//-============================================================================
//  tH_c[IuWFNg悹(\)TWinControl̉
//-============================================================================
destructor TplExplorerFolderTree.Destroy;
begin
  if m_dwTreeCookie <> 0 then m_pNameSpaceTreeControl.TreeUnadvise(m_dwTreeCookie);

  if FpidlRootFolder   <> nil then CoTaskMemFree(FpidlRootFolder);
  if FpidlSelectFolder <> nil then CoTaskMemFree(FpidlSelectFolder);

  inherited;
end;

//-============================================================================
//  R|SetParent\bh
//  ŃGNXv[̃C^[tFCXIuWFNg𐶐
//
//  INameSpaceTreeControC^tFCXIuWFNǵCrWAȃIuWFNg
//  Ȃ̂OnCreateƎs\̂ŁCI[oChSetPrent\b
//  hŐ
//  SetPrent\bh́CR|̐Cj̍ۓCďôŒ
//-============================================================================
procedure TplExplorerFolderTree.SetParent(AParent: TWinControl);
var
  rc  : TRect;
begin
  inherited;

  if Parent = nil then exit;
  if csDesigning in ComponentState then exit;

  if m_pNameSpaceTreeControl = nil then begin
    //INameSpaceControlC^[tFCX̃IuWFNg𐶐Ď擾
    if Failed(CoCreateInstance(CLSID_NamespaceTreeControl,
                               nil,
                               CLSCTX_INPROC_SERVER,
                               INameSpaceTreeControl,
                               m_pNameSpaceTreeControl)) then exit;

    //擾IuWFNg̏
    SetRectEmpty(rc);
    if Failed(m_pNameSpaceTreeControl.Initialize(
                               Handle,
                               rc,
                               NSTCS_HASEXPANDOS or
                               NSTCS_SHOWSELECTIONALWAYS or
                               NSTCS_BORDER or
                               NSTCS_TABSTOP)) then exit;

    //IuWFNg̗L(̒ʒm󂯎\ɂ)
    if Failed(m_pNameSpaceTreeControl.TreeAdvise(
                               INameSpaceTreeControlCustomDraw(Self),
                               m_dwTreeCookie)) then exit;

    //tH_c[̃nh(HwndTree)擾
    IUnknown_GetWindow(m_pNameSpaceTreeControl, FhwndTree);

    Application.OnIdle := OnIdleEvent;
  end;
end;

//-============================================================================
//  ƃRg[̔zuɂ̂clWhiteœhԂ
//  (R|[lgƂēo^Ďgpꍇ̑΍)
//  WM_ERASEBKGNDŃobNOEh̏sĂȂ̂ŁC`ׂ͂Paint
//  \bhŎsKv
//-============================================================================
procedure TplExplorerFolderTree.Paint;
var
  ARect : TRect;
  Flags : Longint;
begin
  inherited Paint;

  with Canvas do begin
    Brush.Color := clWhite;
    FillRect(ClientRect);

    if Caption <> '' then begin
      ARect       := ClientRect;
      Brush.Style := bsClear;
      Font        := Self.Font;
      Flags       := DT_SINGLELINE or DT_CENTER or DT_VCENTER;
      DrawText(Handle, Caption, -1, ARect, Flags);
    end;
  end;
end;

//-============================================================================
//  [gtH_̐ݒ
//  RootFoldervpeB̐ݒ胁\bh
//  ̃tH_̊Kw̃tH_͕\Ȃ
//-============================================================================
procedure TplExplorerFolderTree.SetFRootFolder(const Value: String);

  //---------------------------------------------------------------------------
  //  ۂ̃[gtH_ݒƁCݕ\̃c[폜
  //---------------------------------------------------------------------------
  function SetRoot_TreeControlHost(pidl: PItemIDList): Boolean;
  var
    pShellItem : IShellItem;
  begin
    Result := False;

    if Failed(SHCreateItemFromIDList(pidl, IShellItem, pShellItem)) then exit;

    //擾m_pShellItem烋[gtH_𐶐ăc[
    //ł̓tH_(SHCONTF_FOLDERS)݂̂̕\ɐݒ
    if Failed(m_pNameSpaceTreeControl.AppendRoot(
                                pShellItem,
                                SHCONTF_FOLDERS,
                                NSTCRS_VISIBLE or NSTCRS_EXPANDED,
                                nil)) then exit;

    //Ƀ[gtH_̐ݒ肪΍폜
    //ŏɍ폜ƃACe\Ȃꍇ
    if m_pShellItem <> nil then begin
      if Failed(m_pNameSpaceTreeControl.RemoveRoot(m_pShellItem)) then exit;
    end;
    //VShellItemIuWFNg
    m_pShellItem := pShellItem;
    pShellItem   := nil;

    Result := True;
  end;
  //---------------------------------------------------------------------------

var
  pidl : PItemIDList;
begin
  if @IUnknown_GetWindow = nil then exit;
  if (Value <> '') and (Value = FRootFolder) then exit;

  pidl := nil;

  //󕶎ȂfXNgbv[gtH_ɂ
  //󕶎ȊȌꍇ́Cڎʎq߂ĂɊYtH_[gɂ
  if Value = '' then begin
    SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, pidl);
  end else begin
    pidl := ILCreateFromPath(PChar(Value));
    if pidl = nil then exit;
  end;

  //ۂ̃[gtH_̐ݒ
  if SetRoot_TreeControlHost(pidl) = False then begin
    CoTaskMemFree(pidl);
    exit;
  end;

  FRootFolder     := Value;
  FpidlRootFolder := ILClone(pidl);

  //CxgɈn
  if Assigned(FOnRootFolderChanged) then begin
    FOnRootFolderChanged(Self, FpidlRootFolder, FRootFolder);
  end;
  CoTaskMemFree(pidl);
end;

//-============================================================================
//  ItH_̎w
//  SelectFoldervpeB̐ݒ胁\bh
//-============================================================================
procedure TplExplorerFolderTree.SetFSelectFolder(const Value: String);
var
  pidl : PItemIDList;
begin
  if Value = ''  then exit;

  //tH_̃pX獀ڎʎq擾
  pidl := ILCreateFromPath(PChar(Value));
  if pidl = nil then exit;
  if ILIsEqual(FpidlSelectFolder, pidl) then begin
    CoTaskMemFree(pidl);
    exit;
  end;

  SetFpidlSelectFolder(pidl);
  CoTaskMemFree(pidl);
end;

//-============================================================================
//  ItH_̐ݒ(ڎʎqɂݒ)
//  pidlSelectFoldervpeB̐ݒ胁\bh
//-============================================================================
procedure TplExplorerFolderTree.SetFpidlSelectFolder(const Value: PItemIDList);
var
  pShellItem : IShellItem;
  nsMask     : NSTCITEMSTATE;
  nsFlags    : NSTCITEMSTATE;
begin
  if Value = nil then exit;

  if ILIsEqual(Value, FpidlSelectFolder) = False then begin
    //[gtH_̊Kw𒲍
    if ILIsParent(FpidlRootFolder, Value, False) = False then begin
      exit;
    end;

    //ڎʎqIShellItemIuWFNg擾
    if Failed(SHCreateItemFromIDList(Value, IShellItem, pShellItem)) then begin
      exit;
    end;

    //擾IShellItemgpSetItemState\bhsđI
    //nsMaskNSTCIS_EXPANDED܂߂΃TutH_WJ
    nsMask  := NSTCIS_SELECTED;
    nsFlags := nsMask;
    m_pNameSpaceTreeControl.SetItemState(pShellItem, nsMask, nsFlags);

    pShellItem        := nil;
    FpidlSelectFolder := ILClone(Value);
  end;
end;

//-============================================================================
//  `h~
//  {Rg[gɂ͉`悵Ȃ̂ŃobNOEh͂Ȃ
//-============================================================================
procedure TplExplorerFolderTree.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 0;
end;

//-============================================================================
//  EBhEvV[W[
//  tH_c[̈ʒuƃTCY̐ݒ蓙
//-============================================================================
procedure TplExplorerFolderTree.WndProc(var Message: TMessage);
begin
  inherited WndProc(Message);

  if Message.Msg = WM_SIZE then begin
    if (FhwndTree <> 0) then begin
      MoveWindow(FhwndTree, 0, 0, Width, Height, True);
    end;
  end;
end;

//-============================================================================
//  L[֌W̏p
//  ꂪȂƁCANZ[^L[̓삪sȂ
//  ݌vɂ͂sȂ悤ɂDsƃGfB^ɋ@\Ȃ
//-============================================================================
procedure TplExplorerFolderTree.OnIdleEvent(Sender: TObject; var Done: Boolean);
var
  Amsg : Msg;
begin
  if csDesigning in ComponentState then exit;

  while True do begin
    if GetMessage(AMsg, 0, 0, 0) = False then begin
      PostQuitMessage(0);
      break;
    end;
    TranslateMessage(Amsg);
    DispatchMessage(Amsg);
  end;
end;


//------------------ ȉC^[tFCX֌W֐ ---------------------------


//-----------------------------------------------------------------------------
//  QƃJE^̖
//  Delphi 2010̂݁DDelphi XE, XE2ł͕sv
//-----------------------------------------------------------------------------
function TplExplorerFolderTree._AddRef: Integer;
begin
  Result := -1;
end;

//-----------------------------------------------------------------------------
//  QƃJE^̖
//  Delphi 2010̂݁DDelphi XE, XE2ł͕sv
//-----------------------------------------------------------------------------
function TplExplorerFolderTree._Release: Integer;
begin
  Result := -1;
end;

//-----------------------------------------------------------------------------
//  INameSpaceTreeControlCustomDraw::ItemPostPaint
//  http://msdn.microsoft.com/en-us/library/bb761616%28v=VS.85%29.aspx
//-----------------------------------------------------------------------------
function TplExplorerFolderTree.ItemPostPaint(hdc: HDC; var prc: TRect;
  var pnstccdItem: TNSTCCustomDraw): HRESULT;
begin
  Result := S_OK;
end;

//-----------------------------------------------------------------------------
//  INameSpaceTreeControlCustomDraw::ItemPrePaint
//  http://msdn.microsoft.com/en-us/library/bb761617%28v=VS.85%29.aspx
//
//  IACẽeLXgFύX
//  ItH_ɑ΂Cxg
//-----------------------------------------------------------------------------
function TplExplorerFolderTree.ItemPrePaint(hdc: HDC; var prc: TRect;
  var pnstccdItem: TNSTCCustomDraw; var pclrText, pclrTextBk: COLORREF;
  var plres: LRESULT): HRESULT;
var
  pShellItem      : IShellItem;
  pShellItemArray : IShellItemArray;
  pidl            : PItemIDList;
  pFullPath       : array [0..MAX_PATH - 1] of Char;
begin
  if (pnstccdItem.uItemState and CDIS_FOCUS) > 0 then begin
    pclrText := RGB(200, 0, 0);
    plres    := CDRF_NEWFONT;
  end;

  //IACẽtpX擾
  //ztH_͋󕶎
  if (pnstccdItem.uItemState and CDIS_SELECTED) > 0 then begin
    if m_pNameSpaceTreeControl.GetSelectedItems(pShellItemArray) = S_OK then begin
      if Succeeded( pShellItemArray.GetItemAt(0, pShellItem)) then begin
        if Succeeded(SHGetIDListFromObject(pShellItem, pidl)) then begin

          if ILIsEqual(FpidlSelectFolder, pidl) = False then begin
            SHGetPathFromIDList(pidl, pFullPath);
            FpidlSelectFolder := ILClone(pidl);
            FSelectFolder     := pFullPath;

            //CxgɈn
            if Assigned(FOnSelctFolderChanged) then begin
              FOnSelctFolderChanged(Self, FpidlSelectFolder, FSelectFolder);
            end;
          end;
          CoTaskMemFree(pidl);
        end;
        pShellItem := nil;
      end;
      pShellItemArray := nil;
    end;
  end;

  Result := S_OK;
end;

//-----------------------------------------------------------------------------
//  INameSpaceTreeControlCustomDraw::PostPaint
//  http://msdn.microsoft.com/en-us/library/bb761618%28v=VS.85%29.aspx
//-----------------------------------------------------------------------------
function TplExplorerFolderTree.PostPaint(hdc: HDC; var prc: TRect): HRESULT;
begin
  Result := S_OK;
end;

//-----------------------------------------------------------------------------
//  INameSpaceTreeControlCustomDraw::PrePaint
//  http://msdn.microsoft.com/en-us/library/bb761619%28v=VS.85%29.aspx
//-----------------------------------------------------------------------------
function TplExplorerFolderTree.PrePaint(hdc: HDC; var prc: TRect;
  var plres: LRESULT): HRESULT;
begin
  plres  := CDRF_NOTIFYITEMDRAW;
  Result := S_OK;
end;

//=============================================================================
//  R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplExplorerFolderTree]);
end;

end.
