//-============================================================================
//  GNXv[tH[ɔzuĎgp邽߂̃NX(R|[lg)
//  tH_r[(t@CXg)yC\
//
//  EternalWindowsƂTCg̈ȉ̃y[WC++R[hDelphiɈڐA
//  [tH_̐؂ւ]
//  http://eternalwindows.jp/shell/explorerbrowser/explorerbrowser02.html
//
//  GNXv[֌W̃C^[tFCXIuWFNg悹(\)߂
//  TCustomPanel𐶐CŏɃ[gtH_ݒ肷鎞ɃGNXv[֌W
//  ̃IuWFNg𐶐
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؂̊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2010N1119 `
//  2010N1123
//  EtH_c[Ƃ̘Aĝ߂ɍڎʎqɂ̃[gƓWJtH_̃v
//    peBǉDWJtH_ύX̃Cxgǉ
//  2010N1125
//  EILFreeCoTaskMemFreeɏC
//  2011N0103
//  EC^[tFCXTCustomPanel̃o[ɂ
//  2011N0920
//  EC^[tFCXsɐR[hɕύX
//  EDelphi 2010ł̎QƃJE^̖C(Delphi XE2ł͂̏C͕sv)
//    fobN[hł̗Ỏ
//    ڍׂ̓ICwv[QƃJEggȂ][QƃJEg̎g]Q
//  E\ύXɕ\XVȂۂC
//  EXbh̎gp~߂āCOnIdleCxgɕύX
//  EDelphi 2010łShlObj.pas̏C@Rgɒǉ
//
//-----------------------------------------------------------------------------
//
//  []
//  IExplorerBrowserŃGNXv[\@́CTListView̎ɔׂĊ
//  Pł͂邪C@\IȕύXǉ͍
//  ̂܂܂̎dlł悢̂łΗpl͂邩mȂ
//  \`SĂT|[gĂ킯ł͂Ȃ悤
//
//-----------------------------------------------------------------------------
//
//  ymFz (Delphi for Win32)
//
//  Windows 7 U64 + Delphi 2010(UP5) Pro
//                + Delphi XE Pro
//                + Delphi XE2 Pro VCL-32, VCL-64
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//-============================================================================
unit plExplorerFolderView;

interface

uses
  {$IF CompilerVersion < 23.0}
  Windows, Messages, SysUtils, Variants, Classes, Controls, ShlObj, ActiveX,
  ExtCtrls, Graphics, Types, Forms;
  {$ELSE}
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Controls, Winapi.ShlObj, Winapi.ActiveX, Vcl.ExtCtrls, Vcl.Graphics,
  System.Types, Vcl.Forms;
  {$IFEND}

type
  TpExplorerFolderViewChanged = procedure(Sender: TObject; pidlFolder: PItemIDList;
                                          AFullPath: String) of object;

  TplExplorerFolderView = class(TCustomPanel, IExplorerBrowserEvents)
  private
    FExpandFolder          : String;
    FRootFolder            : String;
    FpidlRootFolder        : PItemIDList;
    FpidlExpandFolder      : PItemIDList;
    FViewMode              : Cardinal;
    FOnExpandFolderChanged : TpExplorerFolderViewChanged;

    m_dwCookie         : DWORD;
    m_pShellView       : IShellView;
    m_pExplorerBrowser : IExplorerBrowser;

    procedure SetFExpandFolder(const Value: String);
    procedure SetFRootFolder(const Value: String);
    procedure SetFViewMode(const Value: Cardinal);
    procedure SetFpidlExpandFolder(const Value: PItemIDList);
    procedure SetFpidlRootFolder(const Value: PItemIDList);
  protected
    procedure WndProc(var Message: TMessage); override;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure Paint; override;
    procedure SetParent(AParent: TWinControl); override;
    procedure OnIdleEvent(Sender: TObject; var Done: Boolean);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    function NavigateBack: Boolean;
    function NavigateForward: Boolean;
    property pidlRootFolder   : PItemIDList read  FpidlRootFolder
                                            write SetFpidlRootFolder;
    property pidlExpandFolder : PItemIDList read  FpidlExpandFolder
                                            write SetFpidlExpandFolder;

    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
    function OnNavigationPending(pidlFolder: PItemIDList): HRESULT; stdcall;
    function OnViewCreated(const psv: IShellView): HRESULT; stdcall;
    function OnNavigationComplete(pidlFolder: PItemIDList): HRESULT; stdcall;
    function OnNavigationFailed(pidlFolder: PItemIDList): HRESULT; stdcall;
  published
    property Caption;
    property Align;
    property Anchors;
    property ExpandFolder : String   read FExpandFolder write SetFExpandFolder;
    property RootFolder   : String   read FRootFolder   write SetFRootFolder;
    property ViewMode     : Cardinal read FViewMode     write SetFViewMode;
    property OnExpandFolderChanged : TpExplorerFolderViewChanged
                                     read  FOnExpandFolderChanged
                                     write FOnExpandFolderChanged;
  end;

procedure Register;

implementation

{ TplExplolreFolderView }

//-============================================================================
//  NX(R|[lg)̐
//-============================================================================
constructor TplExplorerFolderView.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  BevelOuter        := bvNone;
  FViewMode         := FVM_THUMBNAIL;
  FRootFolder       := '';
  FpidlRootFolder   := nil;
  FpidlExpandFolder := nil;

  m_dwCookie         := 0;
  m_pShellView       := nil;
	m_pExplorerBrowser := nil;

  Width  := 400;
  Height := 300;
end;

//-============================================================================
//  NX(R|[lg)I
//-============================================================================
destructor TplExplorerFolderView.Destroy;
begin
  if m_dwCookie <> 0 then m_pExplorerBrowser.Unadvise(m_dwCookie);

  if FpidlRootFolder   <> nil then CoTaskMemFree(FpidlRootFolder);
  if FpidlExpandFolder <> nil then CoTaskMemFree(FpidlExpandFolder);

  inherited;
end;

//-============================================================================
//  ŃGNXv[̃C^[tFCXIuWFNg𐶐
//
//  ŎgpC^tFCXIuWFNǵCrWAȃIuWFNgȂ̂
//  OnCreateƎs\̂ŁDI[oChSetPrent\bh
//  
//  SetPrent\bh́CR|̐Cj̍ۓCďôŒ
//
//  FOLDERSETTINGS\̂ViewModefFlags̒lɂĕ\`̕ύXł
//
//  FOLDERSETTINGSViewMode̒l
//  FOLDERVIEWMODE Enumeration
//  http://msdn.microsoft.com/en-us/library/bb762510%28VS.85%29.aspx
//-============================================================================
procedure TplExplorerFolderView.SetParent(AParent: TWinControl);
var
  rc    : TRect;
  hr    : HRESULT;
  fs    : FOLDERSETTINGS;
  ARect : TRect;
  {$IF CompilerVersion < 23.0}
  phdwp : Cardinal;
  {$ELSE}
  phdwp : NativeUInt;
  {$IFEND}
  psbe  : IExplorerBrowserEvents;
begin
  inherited;

  if Parent = nil then exit;
  if csDesigning in ComponentState then exit;

  if m_pExplorerBrowser = nil then begin

    //ExplorerBrowser쐬ɂ́CCoCreateInstanceCLSID_ExplorerBrowserw
    //肵āCExplorerBrowserʂIExplorerBrowser擾
    if Failed( CoCreateInstance(CLSID_ExplorerBrowser,
                                nil,
                                CLSCTX_INPROC_SERVER,
                                IExplorerBrowser,
                                m_pExplorerBrowser)) then exit;

    //InitializeĂяoĎ擾ExplorerBrowser
    fs.ViewMode := FViewMode;
    fs.fFlags   := FWF_NOHEADERINALLVIEWS;
    SetRectEmpty(rc);
    if Failed(m_pExplorerBrowser.Initialize(Handle, rc, fs)) then exit;

    //MDSNłAdvisȇ1[in]ł邪Delphi 2010łvarƂȂĂ̂
    //̑΍.Delphi XEłconstɂȂĂ
    //Delphi 2010łǓ삵Ȃꍇ́CShlObj.pasLibtH_ɃRs[āCAdvise
    //֐̑1constɂ
    psbe := IExplorerBrowserEvents(Self);
    hr   := m_pExplorerBrowser.Advise(psbe, m_dwCookie);
    if Failed(hr) then exit;

    phdwp := 0;
    ARect := Rect(0, 0, Width, Height);
    m_pExplorerBrowser.SetRect(phdwp, ARect);

    Application.OnIdle := OnIdleEvent;
  end;
end;

//-============================================================================
//  ƃRg[̔zuɂ̂clWhiteœhԂ
//  (R|[lgƂēo^Ďgpꍇ̑΍)
//-============================================================================
procedure TplExplorerFolderView.Paint;
var
  ARect : TRect;
  Flags : Longint;
begin
  inherited Paint;

  with Canvas do begin
    Brush.Color := clWhite;
    FillRect(ClientRect);

    if Caption <> '' then begin
      ARect       := ClientRect;
      Brush.Style := bsClear;
      Font        := Self.Font;
      Flags       := DT_SINGLELINE or DT_CENTER or DT_VCENTER;
      DrawText(Handle, Caption, -1, ARect, Flags);
    end;
  end;
end;

//-============================================================================
//  [gtH_̐ݒ
//  ̃tH_̊Kw̃tH_͕\Ȃ
//-============================================================================
procedure TplExplorerFolderView.SetFRootFolder(const Value: String);
var
  pidl : PItemIDList;
begin
  if (FRootFolder <> Value) or (FpidlRootFolder = nil) then begin
    FRootFolder := Value;

    //󔒂ȂfXNgbv
    if FRootFolder = '' then begin
      SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, pidl);
    end else begin
      pidl := ILCreateFromPath(PChar(FRootFolder));
    end;

    SetFpidlRootFolder(pidl);
    if pidl <> nil then CoTaskMemFree(pidl);
  end;
end;

//-============================================================================
//  [gtH_̍ڎʎqɂݒ
//  pidlRootFoldervpeB̐ݒ胁\bh
//  ̃tH_̊Kw̃tH_͕\Ȃ
//-============================================================================
procedure TplExplorerFolderView.SetFpidlRootFolder(const Value: PItemIDList);
var
  pFullPath : array [0..MAX_PATH - 1] of Char;
begin
  if Value = nil then exit;

  if ILIsEqual(Value, FpidlRootFolder) = False then begin
    SHGetPathFromIDList(Value, pFullPath);
    FpidlRootFolder   := ILClone(Value);
    FRootFolder       := pFullPath;
  end;
end;

//-============================================================================
//  \tH_̐ݒ
//  ExpandFoldervpeB̐ݒ胁\bh
//  ۂ̒ĺCC^[tFCX֐Ŏ擾
//-============================================================================
procedure TplExplorerFolderView.SetFExpandFolder(const Value: String);
var
  pidl : PItemIDList;
begin
  if (Value <> '') and (Value = FExpandFolder) then exit;

  //󔒂ȂfXNgbv
  if Value = '' then begin
    if Failed(SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, pidl)) then exit;
  end else begin
    pidl := ILCreateFromPath(PChar(Value));
    if pidl = nil then exit;
  end;

  //ڎʎqŕ\tH_ݒ
  SetFpidlExpandFolder(pidl);

  if pidl <> nil then CoTaskMemFree(pidl);
end;

//-============================================================================
//  \tH_̐ݒ(ڎʎqɂݒ)
//  pidlExpandFoldervpeB̐ݒ胁\bh
//-============================================================================
procedure TplExplorerFolderView.SetFpidlExpandFolder(const Value: PItemIDList);
begin
  if Value = nil then exit;

  if FpidlRootFolder = nil then SetFRootFolder('');

  //\Jn
  if ILIsEqual(Value, FpidlExpandFolder) = False then begin
    m_pExplorerBrowser.BrowseToIDList(Value, SBSP_ABSOLUTE);
  end;
end;

//-============================================================================
//  ߂郁\bh
//  ߂͍̂ŏɕ\tH_܂
//-============================================================================
function TplExplorerFolderView.NavigateBack: Boolean;
var
  hr : HRESULT;
begin
  Result := False;
  if FpidlExpandFolder = nil then exit;

  hr := m_pExplorerBrowser.BrowseToIDList(nil, SBSP_NAVIGATEBACK);
  Result := hr = S_OK;
end;

//-============================================================================
//  iރ\bh
//-============================================================================
function TplExplorerFolderView.NavigateForward: Boolean;
var
  hr : HRESULT;
begin
  Result := False;
  if FpidlExpandFolder = nil then exit;

  hr := m_pExplorerBrowser.BrowseToIDList(nil, SBSP_NAVIGATEFORWARD);
  Result := hr = S_OK;
end;

//-============================================================================
//  \`̕ύX
//  ViewModevpeB̐ݒ胁\bh
//  ACR\̍ۂɁCJ\ɂɂfFlagsݒlύX
//  http://msdn.microsoft.com/en-us/library/bb762510%28VS.85%29.aspx
//  http://msdn.microsoft.com/en-us/library/bb762508%28VS.85%29.aspx
//-============================================================================
procedure TplExplorerFolderView.SetFViewMode(const Value: Cardinal);
var
  fs : FOLDERSETTINGS;
begin
  if FViewMode <> Value then begin
    FViewMode := Value;
    if m_pExplorerBrowser <> nil then begin
      fs.ViewMode := FViewMode;
      fs.fFlags   := FWF_NOCOLUMNHEADER;
      m_pExplorerBrowser.SetFolderSettings(fs);
      if m_pShellView <> nil then m_pShellView.Refresh;
    end;
  end;
end;

//-============================================================================
//  {Rg[gɂ͉`悵Ȃ̂ŃobNOEh͂Ȃ
//-============================================================================
procedure TplExplorerFolderView.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 0;
end;

//-============================================================================
//  EBhvV[W[
//-============================================================================
procedure TplExplorerFolderView.WndProc(var Message: TMessage);
var
  ARect : TRect;
  {$IF CompilerVersion < 23.0}
  phdwp : Cardinal;
  {$ELSE}
  phdwp : NativeUInt;
  {$IFEND}
begin
  inherited WndProc(Message);

  if (Message.Msg = WM_SIZE) then begin
    if m_pExplorerBrowser <> nil then begin
      phdwp := 0;
      ARect := Rect(0, 0, Width, Height);
      m_pExplorerBrowser.SetRect(phdwp, ARect);
    end;
  end;
end;

//-============================================================================
//  L[֌W̏p
//  ꂪȂƁCႦ[O̕ύX]삪ɋ@\Ȃ
//  ݌vɂ͂sȂ悤ɂDsƃGfB^ɋ@\Ȃ
//-============================================================================
procedure TplExplorerFolderView.OnIdleEvent(Sender: TObject; var Done: Boolean);
var
  Amsg : Msg;
begin
  if csDesigning in ComponentState then exit;

  while True do begin
    if GetMessage(AMsg, 0, 0, 0) = False then begin
      PostQuitMessage(0);
      break;
    end;
		if (m_pShellView = nil) or (m_pShellView.TranslateAccelerator(AMsg) <> S_OK)
    then begin
      TranslateMessage(Amsg);
      DispatchMessage(Amsg);
    end;
  end;
end;


//------------------ ȉC^[tFCX֌W֐ ---------------------------


//-----------------------------------------------------------------------------
//  QƃJE^̖
//  Delphi 2010̂݁DDelphi XE, XE2ł͕sv
//-----------------------------------------------------------------------------
function TplExplorerFolderView._AddRef: Integer;
begin
  Result := -1;
end;

//-----------------------------------------------------------------------------
//  QƃJE^̖
//  Delphi 2010̂݁DDelphi XE, XE2ł͕sv
//-----------------------------------------------------------------------------
function TplExplorerFolderView._Release: Integer;
begin
  Result := -1;
end;

//-----------------------------------------------------------------------------
//  IExplorerBrowserEvents::OnNavigationPending
//  http://msdn.microsoft.com/en-us/library/bb761890%28VS.85%29.aspx
//
//  tH_؂ւ悤ƂƁCŏɂOnNavigationPendingĂ΂
//  S_OKԂƐVtH_̒g\OnViewCreated
//  ̌OnNavigationCompleteĂ΂
//
//  ߂邱ƂłȂꍇOnNavigationPending͌Ă΂Ȃ
//  ł̓[gtH_̊KwłȂƃtH_̕\ύXȂ悤ɂ
//  Ă
//  ILIsEqual֐ŔrCCxgݒ肷΁CO[߂]{^̔\
//  ̐䂪\
//-----------------------------------------------------------------------------
function TplExplorerFolderView.OnNavigationPending(
  pidlFolder: PItemIDList): HRESULT;
begin
  if ILIsParent(FpidlRootFolder, pidlFolder, False) then begin
    Result := S_OK;
  end else begin
    Result := E_NOTIMPL;
  end;
end;

//-----------------------------------------------------------------------------
//  IExplorerBrowserEvents::OnViewCreated
//  http://msdn.microsoft.com/en-us/library/bb761892%28VS.85%29.aspx
//-----------------------------------------------------------------------------
function TplExplorerFolderView.OnViewCreated(const psv: IShellView): HRESULT;
begin
  m_pShellView := psv;
  Result       := S_OK;
end;

//-----------------------------------------------------------------------------
//  IExplorerBrowserEvents::OnNavigationComplete
//  http://msdn.microsoft.com/en-us/library/bb761885%28VS.85%29.aspx
//
//  tH_WJ̃Cxgs
//-----------------------------------------------------------------------------
function TplExplorerFolderView.OnNavigationComplete(
  pidlFolder: PItemIDList): HRESULT;
var
  pFullPath : array [0..MAX_PATH - 1] of Char;
begin
  //CxgɈn
  if ILIsEqual(FpidlExpandFolder, pidlFolder) = False then begin
    SHGetPathFromIDList(pidlFolder, pFullPath);
    FpidlExpandFolder := ILClone(pidlFolder);
    FExpandFolder     := pFullPath;

    if Assigned(FOnExpandFolderChanged) then begin
      FOnExpandFolderChanged(Self, FpidlExpandFolder, FExpandFolder);
    end;
  end;

  Result := S_OK;
end;

//-----------------------------------------------------------------------------
//  IExplorerBrowserEvents::OnNavigationFailed
//  http://msdn.microsoft.com/en-us/library/bb761887%28VS.85%29.aspx
//-----------------------------------------------------------------------------
function TplExplorerFolderView.OnNavigationFailed(
  pidlFolder: PItemIDList): HRESULT;
begin
  Result := S_OK;
end;

//=============================================================================
//  R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplExplorerFolderView]);
end;

end.
