//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//-============================================================================
//  GNXv[tH[ɔzuĎgp邽߂̃NX(R|[lg)
//
//  EternalWindowsƂTCg̈ȉ̃y[WC++R[hDelphiɈڐA
//  [ExplorerBrowser̍쐬]
//  http://eternalwindows.jp/shell/explorerbrowser/explorerbrowser01.html
//
//  GNXv[֌W̃C^[tFCXIuWFNg悹(\)߂
//  TCustomPanel𐶐CŏɃ[gtH_ݒ肷鎞ɃGNXv[֌W
//  ̃IuWFNg𐶐
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؂̊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2010N1118 `
//  2010N1125
//  EILFreeCoTaskMemFreeɏC
//  2011N0103
//  EC^[tFCXTCustomPanel̃o[ɂ
//  2011N0920
//  EC^[tFCXsɐR[hɕύX
//  EXbh̎gp~߂āCOnIdleCxgɕύX
//
//-----------------------------------------------------------------------------
//
//  ymFz 
//
//  Windows 7 U64 + Delphi XE Pro
//                + Delphi XE2 Pro VCL-32, VCL-64
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//-============================================================================
unit plExplorerBrowser;

interface

uses
  {$IF CompilerVersion < 23.0}
  Windows, Messages, SysUtils, Variants, Classes, Controls, ShlObj, ActiveX,
  ExtCtrls, Graphics, Types, Forms;
  {$ELSE}
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Controls, Winapi.ShlObj, Winapi.ActiveX, Vcl.ExtCtrls, Vcl.Graphics,
  System.Types, Vcl.Forms;
  {$IFEND}

type
  TplExplorerBrowser = class(TCustomPanel,
                             IServiceProvider,
                             IExplorerPaneVisibility, IFolderFilter)
  private
    FSelectFolder      : String;
    FViewMode          : Cardinal;
    m_pExplorerBrowser : IExplorerBrowser;
    procedure SetFSelectFolder(const Value: String);
  protected
    procedure WndProc(var Message: TMessage); override;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure SetParent(AParent: TWinControl); override;
    procedure Paint; override;
    procedure OnIdleEvent(Sender: TObject; var Done: Boolean);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    function QueryService(const rsid, iid: TGuid; out Obj): HResult; stdcall;
    function GetPaneState(const ep: EXPLORERPANE;
      var peps: TExplorerPaneState): HRESULT; stdcall;
    function ShouldShow(const psf: IShellFolder; pidlFolder: PItemIDList;
      pidlItem: PItemIDList): HRESULT; stdcall;
    function GetEnumFlags(const psf: IShellFolder; pidlFolder: PItemIDList;
      var phwnd: HWND; var pgrfFlags: DWORD): HRESULT; stdcall;
  published
    property Caption;
    property Align;
    property Anchors;
    property SelectFolder : String   read FSelectFolder write SetFSelectFolder;
    property ViewMode     : Cardinal read FViewMode     write FViewMode;
  end;

  fIUnknown_SetSite = function (punk: IUnknown; punkSite: IUnknown): HRESULT;
                      stdcall;
procedure Register;

implementation

var
  IUnknown_SetSite : fIUnknown_SetSite;

{ TplExplorerBrowser }

//-============================================================================
//  NX(R|[lg)̐
//  DLLDLL̊֐̃AhX擾
//-============================================================================
constructor TplExplorerBrowser.Create(AOwner: TComponent);
var
  DLLHandle : THandle;
begin
  inherited Create(AOwner);

  DLLHandle := LoadLibrary('shlwapi.dll');
  if DLLHandle <> 0 then begin
    @IUnknown_SetSite := GetProcAddress(DLLHandle,'IUnknown_SetSite');
  end;

  m_pExplorerBrowser := nil;
  BevelOuter         := bvNone;
  FViewMode          := FVM_DETAILS;

  Width  := 650;
  Height := 420;
end;

//-============================================================================
//  NX(R|[lg)I
//-============================================================================
destructor TplExplorerBrowser.Destroy;
begin
  inherited;
end;

//-============================================================================
//  ŃGNXv[̃C^[tFCXIuWFNg𐶐
//
//  IExplorerBrowserC^tFCXIuWFNǵCrWAȃIuWFNgȂ
//  OnCreateƎs\DI[oChSetPrent\bh
//  Ő
//  SetPrent\bh́CR|̐Cj̍ۓCďôŒ
//
//  FOLDERSETTINGSViewMode̒l
//  FOLDERVIEWMODE Enumeration
//  http://msdn.microsoft.com/en-us/library/bb762510%28VS.85%29.aspx
//-============================================================================
procedure TplExplorerBrowser.SetParent(AParent: TWinControl);
var
  rc                : TRect;
  fs                : FOLDERSETTINGS;
  ARect             : TRect;
  pFolderFilterSite : IFolderFilterSite;
  punk              : IInterface;
  {$IF CompilerVersion < 23.0}
  phdwp : Cardinal;
  {$ELSE}
  phdwp : NativeUInt;
  {$IFEND}
begin
  inherited;

  if Parent = nil then exit;
  if csDesigning in ComponentState then exit;

  if m_pExplorerBrowser = nil then begin
    //IExplorerBrowserC^[tFCX̃IuWFNg𐶐Ď擾
    if Failed(CoCreateInstance(CLSID_ExplorerBrowser,
                               nil,
                               CLSCTX_INPROC_SERVER,
                               IExplorerBrowser,
                               m_pExplorerBrowser)) then exit;

    fs.ViewMode := FViewMode;
    fs.fFlags   := 0;
    SetRectEmpty(rc);
    if Failed(m_pExplorerBrowser.Initialize(Handle, rc, fs)) then exit;

    m_pExplorerBrowser.SetOptions(EBO_SHOWFRAMES or EBO_ALWAYSNAVIGATE);
    IUnknown_SetSite(m_pExplorerBrowser, Self);

    //ShouldShow\bhŕ\tB^Lɂ邽߂ɕKv
    m_pExplorerBrowser.QueryInterface(IID_IFolderFilterSite, pFolderFilterSite);

    //MDSNłSetFilter̈[in]ł邪Delphi 2010łvarƂȂĂ̂
    //̑΍.Delphi XEłconstɂȂĂ
    punk := IFolderFilter(Self);
    pFolderFilterSite.SetFilter(punk);

    phdwp := 0;
    ARect := Rect(0, 0, Width, Height);
    m_pExplorerBrowser.SetRect(phdwp, ARect);

    Application.OnIdle := OnIdleEvent;
  end;
end;

//-============================================================================
//  ƃRg[̔zuɂ̂clWhiteœhԂ
//  (R|[lgƂēo^Ďgpꍇ̑΍)
//-============================================================================
procedure TplExplorerBrowser.Paint;
var
  ARect : TRect;
  Flags : Longint;
begin
  inherited Paint;

  with Canvas do begin
    Brush.Color := clWhite;
    FillRect(ClientRect);

    if Caption <> '' then begin
      ARect       := ClientRect;
      Brush.Style := bsClear;
      Font        := Self.Font;
      Flags       := DT_SINGLELINE or DT_CENTER or DT_VCENTER;
      DrawText(Handle, Caption, -1, ARect, Flags);
    end;
  end;
end;

//-============================================================================
//  {Rg[gɂ͉`悵Ȃ̂ŃobNOEh͂Ȃ
//-============================================================================
procedure TplExplorerBrowser.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  Message.Result := 0;
end;

//-============================================================================
//  {Rg[̃EBhvV[W[
//-============================================================================
procedure TplExplorerBrowser.WndProc(var Message: TMessage);
var
  ARect : TRect;
  {$IF CompilerVersion < 23.0}
  phdwp : Cardinal;
  {$ELSE}
  phdwp : NativeUInt;
  {$IFEND}
begin
  inherited WndProc(Message);

  if Message.Msg = WM_SIZE then begin
    if m_pExplorerBrowser <> nil then begin
      phdwp := 0;
      ARect := Rect(0, 0, Width, Height);
      m_pExplorerBrowser.SetRect(phdwp, ARect);
    end;
  end;
end;

//-============================================================================
//  ItH_̐ݒ
//  vpeBSelectFolder̐ݒ胁\bh
//
//  Őݒ肵tH_IԂɂDtH_r[(t@CXg)
//  ̃tH_̃t@CXg
//-============================================================================
procedure TplExplorerBrowser.SetFSelectFolder(const Value: String);
var
  pidl : PItemIDList;
begin
  if @IUnknown_SetSite = nil then exit;
  if (Value <> '') and (Value = FSelectFolder) then exit;

  FSelectFolder := Value;

  //󔒂ȂfXNgbv
  if FSelectFolder = '' then begin
    if Failed(SHGetSpecialFolderLocation(0, CSIDL_DESKTOP, pidl)) then exit;
  end else begin
    pidl := ILCreateFromPath(PChar(FSelectFolder));
    if pidl = nil then exit;
  end;
  //\Jn
	m_pExplorerBrowser.BrowseToIDList(pidl, SBSP_ABSOLUTE);

  CoTaskMemFree(pidl);
end;

//-============================================================================
//  L[ĎJn
//  tH_r[(t@CXg)ł͈ꕔ@\Ȃ悤ł
//  ܂CANZ[^[L[͋@\Ȃ
//-============================================================================
procedure TplExplorerBrowser.OnIdleEvent(Sender: TObject; var Done: Boolean);
var
  Amsg : Msg;
begin
  if csDesigning in ComponentState then exit;

  while True do begin
    if GetMessage(AMsg, 0, 0, 0) = False then begin
      PostQuitMessage(0);
      break;
    end;
    TranslateMessage(Amsg);
    DispatchMessage(Amsg);
  end;
end;



//------------------ ȉC^[tFCX֌W֐ ---------------------------


//-----------------------------------------------------------------------------
//  IServiceProvider::QueryService
//  http://msdn.microsoft.com/en-us/library/cc678966%28VS.85%29.aspx
//-----------------------------------------------------------------------------
function TplExplorerBrowser.QueryService(const rsid, iid: TGuid;
  out Obj): HResult;
begin
	Result := QueryInterface(iid, Obj);
end;

//-----------------------------------------------------------------------------
//  IExplorerPaneVisibility::GetPaneState
//  http://msdn.microsoft.com/en-us/library/bb761856%28VS.85%29.aspx
//
//  ̃\bhŕ\yC̕\E\̕ύX\
//  \ɂpeps̒lEPS_DEFAULT_ONɂ
//  \ŏԂ̕ύXsɂɂEPS_DEFAULT_OFF or EPS_FORCE
//  o͈ȉ̂悤ɂł
//  if IsEqualGUID(ep, EP_NavPane) then begin
//
//  --------------------------------------------------
//  |     EP_Commands                                |
//  --------------------------------------------------
//  |             |                 |                |
//  |             |                 |                |
//  |             |                 |                |
//  | EP_NavPane  |                 | EP_PreviewPane |
//  | irQ[^  |    ɕ\     | t@C     |
//  | yC      |                 | vr[̈ |
//  |             |                 |                |
//  |             |                 |                |
//  |             |                 |                |
//  --------------------------------------------------
//  |     EP_DetailsPane                             |
//  --------------------------------------------------
//
//-----------------------------------------------------------------------------
function TplExplorerBrowser.GetPaneState(const ep: EXPLORERPANE;
  var peps: TExplorerPaneState): HRESULT;
begin
  peps   := EPS_DEFAULT_ON;
  Result := S_OK;
end;

//-----------------------------------------------------------------------------
//  IFolderFilter::ShouldShow
//  http://msdn.microsoft.com/en-us/library/bb775628%28v=VS.85%29.aspx
//
//  ItH_(tH_r[ t@CXgtH_)̃tpX擾
//  āCSelectFoldervpeBɑ
//  ł͉B̃t@C\ݒ
//-----------------------------------------------------------------------------
function TplExplorerBrowser.ShouldShow(const psf: IShellFolder; pidlFolder,
  pidlItem: PItemIDList): HRESULT;
var
  pFullPath : array [0..MAX_PATH - 1] of Char;
  Attrib    : Cardinal;
begin
  SHGetPathFromIDList(pidlFolder, pFullPath);
  FSelectFolder := pFullPath;

  psf.GetAttributesOf(1, pidlItem, Attrib);
  if ((SFGAO_HIDDEN and Attrib) > 0) or ((SFGAO_GHOSTED and Attrib) > 0) then begin
    Result := S_FALSE;
  end else begin
    Result := S_OK;
  end;
end;

//-----------------------------------------------------------------------------
//  IFolderFilter::GetEnumFlags
//  http://msdn.microsoft.com/en-us/library/bb775624%28v=VS.85%29.aspx
//-----------------------------------------------------------------------------
function TplExplorerBrowser.GetEnumFlags(const psf: IShellFolder;
  pidlFolder: PItemIDList; var phwnd: HWND; var pgrfFlags: DWORD): HRESULT;
begin
  Result := S_OK;
end;

//=============================================================================
//  R|[lgo^
//=============================================================================
procedure Register;
begin
  RegisterComponents('plXRAY', [TplExplorerBrowser]);
end;

end.
